/* Program demonstrira cekanje na zavrsetak niti. Zato sto glavna nit
   (program) ceka na svaku nit da se zavrsi, niti ce sigurno biti
   zavrsene redosledom kojim su kreirane. Ovo nema smisla, jer ideja u
   radu sa nitima je upravo da se izvrsavaju paralelno a ne
   sekvencijalno.*/
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#define NUM_THREADS 20

void error_fatal(char *message)
{
  perror(message);
  exit (EXIT_FAILURE);
}

/* Posebna funkcija koja se poziva kada dodje do greske pri radu sa
   nitima. */
void pthread_error(char *message, int err)
{
  /* Funkcija strerror na osnovu vrednosti celobrojnog koda greske
     vraca pokazivac na string koji detaljnije opisuje gresku. */
  fprintf(stderr, "%s : %s\n", message, strerror(err));
  exit (EXIT_FAILURE);
}

void* fun(void *arg)
{
  *((int*)arg) = -(*((int*)arg));
  return arg;
}

int main()
{
  int err;
  int i;
  pthread_t tid;
  for(i = 0; i < NUM_THREADS; i++)
  {
    /* Alokacija neophodne memorije. */
    int *num = (int*)malloc(sizeof(int));
    void *ret_value;
    if(num == NULL)
      error_fatal ("malloc error");
    *num = i;

    /* Kreiranje niti. */
    if( (err = pthread_create(&tid, NULL, fun, num)) != 0)
      pthread_error ("thread create error", err);

    /* Cekanje da nit zavrsi sa poslom. Posto se na nit ceka, pa se
       tek onda ide u narednu iteraciju petlje, niti ce biti
       zavrsavane redosledom kojim su pozvane. 

       NAPOMENA: Ovo je losa praksa i PRIMER KAKO NE TREBA KORISTITI
       niti. Naime, osnovna ideja je da se niti izvrsavaju
       istovremeno, a na ovaj nacin se sigurno izvrsava jedna po jedna
       nit cime je program obesmisljen. Pogledati naredni primer za
       prikaz pravilnog cekanja na niti.*/
    if( (err = pthread_join(tid, &ret_value)) != 0)
      pthread_error ("pthread join error", err);
    printf("%d\n", *((int*)ret_value));
    /* Moze i stampa *num, jer i num i ret_value pokazuju na istu vrednost. */

    /* Oslobadjanje dinamicki alocirane memorije. */
    free(ret_value); // Potpuno ekvivalentno je free (num)
  }
  
  return 0;
}
